<?php
$placementOptions = [];
if (isset($_POST['PLACEMENT']) && isset($_POST['PLACEMENT_OPTIONS']))
{
	$placementOptions = json_decode($_POST['PLACEMENT_OPTIONS'], true);
}

header('Content-Type: text/html; charset=UTF-8');
?>
<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8"/>
	<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet">
	<script src="https://cdn.jsdelivr.net/npm/jsoneditor@9.9.2/dist/jsoneditor.min.js"></script>
	<link href="https://cdn.jsdelivr.net/npm/jsoneditor@9.9.2/dist/jsoneditor.min.css" rel="stylesheet">
	<script src="//api.bitrix24.com/api/v1/"></script>
</head>
<body>
<main>
	<div class="container-fluid">
		<form class="mt-3 mb-3" id="form">
			<div class="row">
				<div class="col-9">
					<div class="mb-3">
						<label class="form-label">Layout json</label>
						<div id="jsoneditor" style="height: 700px"></div>
						<input type="hidden" id="layout" value="{}">
					</div>

					<div class="hstack gap-3">
						<div class="row g-3 me-auto">
							<div class="col-auto">
								<input class="form-control" id="activityId" placeholder="ИД дела">
							</div>
							<div class="col-auto">
								<button type="submit" class="btn btn-outline-secondary" id="getButton">Загрузить</button>
							</div>
							<div class="col-auto">
								<button type="submit" class="btn btn-outline-primary" id="updateButton">Обновить</button>
							</div>
						</div>
						<div class="vr"></div>
						<button type="submit" class="btn btn-primary" id="addButton">Создать</button>
					</div>

				</div>
				<div class="col-3">
					<?php if (!empty($placementOptions)) {?>
					<label class="form-label">Параметры встройки</label>
					<div class="alert alert-primary" role="alert">
						<pre><?php print_R($placementOptions);?></pre>
					</div>
					<hr>
					<?php }?>

					<div class="mb-3">
						<label class="form-label">Родительская сущность</label>
						<div class="row">
							<div class="col-6">
								<select class="form-select"  id="ownerTypeId">
									<option value="1">Лид</option>
									<option selected value="2">Сделка</option>
									<option value="3">Контакт</option>
									<option value="4">Компания</option>
									<option value="7">Коммерческое предложение</option>
									<option value="31">Счёт</option>
								</select>
							</div>
							<div class="col-6">
								<input class="form-control" id="ownerId" placeholder="Идентификатор">
							</div>
						</div>
					</div>

					<div class="mb-3">
						<label class="form-label">responsibleId</label>
						<input class="form-control" id="responsibleId" value="1">
					</div>
					<div class="mb-3">
						<div class="form-check">
							<input class="form-check-input" type="checkbox" value="" id="completed">
							<label class="form-check-label" for="completed">
								completed
							</label>
						</div>
						<div class="form-check">
							<input class="form-check-input" type="checkbox" value="" id="isIncomingChannel">
							<label class="form-check-label" for="isIncomingChannel">
								isIncomingChannel
							</label>
						</div>
					</div>
					<div class="mb-3">
						<label class="form-label">deadline</label>
						<input class="form-control" id="deadline" value="2022-10-01T01:00:00">
					</div>
					<div class="mb-3">
						<label class="form-label">badgeCode</label>
						<input class="form-control" id="badgeCode">
					</div>
					<div class="mb-3">
						<label class="form-label">pingOffsets</label>
						<div class="row">
							<div class="col-4">
								<input class="form-control" id="pingOffset1">
							</div>
							<div class="col-4">
								<input class="form-control" id="pingOffset2">
							</div>
							<div class="col-4">
								<input class="form-control" id="pingOffset3">
							</div>
						</div>

					</div>
			</div>
		</form>
	</div>
</main>
<script>
	document.addEventListener('DOMContentLoaded', () =>
	{
		<?if (($_GET['install'] ?? '') === 'y'):?>
		BX24.installFinish();
		<?php endif?>

		function loadSPATypes()
		{
			BX24.callMethod('crm.type.list', {}, (result) => {
				const types = result?.answer?.result?.types || [];
				types.forEach((item) => {
					const option = document.createElement("option");
					option.value = item.entityTypeId;
					option.innerText = item.title;
					nodes.ownerTypeId.appendChild(option);
				})
			});
		}

		function getData()
		{
			const data = {
				fields: {
					responsibleId: nodes.responsibleId.value,
					badgeCode: nodes.badgeCode.value,
					deadline: nodes.deadline.value,
					completed: nodes.completed.checked ? 'Y' : 'N',
					isIncomingChannel: nodes.isIncomingChannel.checked ? 'Y' : 'N',
					pingOffsets: []
				},
				layout: editor.get()
			};
			if (nodes.pingOffset1.value.length)
			{
				data.fields.pingOffsets.push(nodes.pingOffset1.value);
			}
			if (nodes.pingOffset2.value.length)
			{
				data.fields.pingOffsets.push(nodes.pingOffset2.value);
			}
			if (nodes.pingOffset3.value.length)
			{
				data.fields.pingOffsets.push(nodes.pingOffset3.value);
			}
			if (!data.fields.pingOffsets.length)
			{
				delete data.fields.pingOffsets;
			}

			return data;
		}

		function startLoading()
		{
			nodes.addButton.disabled = true;
			nodes.updateButton.disabled = true;
			nodes.activityId.disabled = true;
			nodes.ownerTypeId.disabled = true;
			nodes.ownerId.disabled = true;
			nodes.completed.disabled = true;
			nodes.isIncomingChannel.disabled = true;
			nodes.deadline.disabled = true;
			nodes.responsibleId.disabled = true;
			nodes.badgeCode.disabled = true;
			nodes.pingOffset1.disabled = true;
			nodes.pingOffset2.disabled = true;
			nodes.pingOffset3.disabled = true;
		}

		function stopLoading()
		{
			nodes.addButton.disabled = false;
			nodes.updateButton.disabled = false;
			nodes.activityId.disabled = false;
			nodes.ownerTypeId.disabled = false;
			nodes.ownerId.disabled = false;
			nodes.completed.disabled = false;
			nodes.isIncomingChannel.disabled = false;
			nodes.deadline.disabled = false;
			nodes.responsibleId.disabled = false;
			nodes.badgeCode.disabled = false;
			nodes.pingOffset1.disabled = false;
			nodes.pingOffset2.disabled = false;
			nodes.pingOffset3.disabled = false;
		}

		const nodes = {
			'form': document.getElementById('form'),
			'addButton': document.getElementById('addButton'),
			'updateButton': document.getElementById('updateButton'),
			'getButton': document.getElementById('getButton'),
			'activityId': document.getElementById('activityId'),
			'ownerTypeId': document.getElementById('ownerTypeId'),
			'ownerId': document.getElementById('ownerId'),
			'completed': document.getElementById('completed'),
			'isIncomingChannel': document.getElementById('isIncomingChannel'),
			'deadline': document.getElementById('deadline'),
			'responsibleId': document.getElementById('responsibleId'),
			'badgeCode': document.getElementById('badgeCode'),
			'pingOffset1': document.getElementById('pingOffset1'),
			'pingOffset2': document.getElementById('pingOffset2'),
			'pingOffset3': document.getElementById('pingOffset3'),
			'layout': document.getElementById('layout'),
			'jsoneditor': document.getElementById('jsoneditor'),
		};

		loadSPATypes();

		const container = nodes.jsoneditor;
		const options = {
			mode: 'code',
			onValidationError: (errors) => {
				if (errors.length)
				{
					alert(errors.map(item => item.message.replaceAll('<br>', "\n")).join("\n\n"));
				}
			}
		};
		const editor = new JSONEditor(container, options);
		editor.set(JSON.parse(nodes.layout.value));

		nodes.form.addEventListener('submit', (e) =>
		{
			e.preventDefault();
		});

		nodes.addButton.addEventListener('click', (e) => {
			e.preventDefault();

			const data = getData();
			if (!nodes.ownerId.value)
			{
				alert('Выберите родительскую сущность');
				nodes.ownerId.focus();
				return false;
			}
			data.ownerTypeId = nodes.ownerTypeId.value;
			data.ownerId = nodes.ownerId.value;

			startLoading();

			BX24.callMethod(
				'crm.activity.configurable.add',
				data,
				(result) =>
				{
					stopLoading();
					if(result.error())
					{
						alert("Error: " + result.error());
					}
					else
					{
						nodes.activityId.value = result.data().activity.id;
					}
				}
			);

			return false;
		});

		nodes.getButton.addEventListener('click', (e) => {
			e.preventDefault();

			if (!nodes.activityId.value)
			{
				alert('Укажите ИД дела');
				return false;
			}

			startLoading();

			BX24.callMethod(
				'crm.activity.configurable.get',
				{
					id: nodes.activityId.value,
				},
				(result) =>
				{
					stopLoading();
					if(result.error())
					{
						alert("Error: " + result.error());
					}
					else
					{
						const activity = result.data().activity;
						nodes.ownerTypeId.value = activity.ownerTypeId;
						nodes.ownerId.value = activity.ownerId;
						nodes.responsibleId.value = activity.fields.responsibleId ?? '';
						nodes.completed.checked = activity.fields.completed ?? false;
						nodes.isIncomingChannel.checked = activity.fields.isIncomingChannel ?? false;
						nodes.deadline.value = activity.fields.deadline ?? '';
						nodes.badgeCode.value = activity.fields.badgeCode ?? '';
						nodes.pingOffset1.value = activity.pingOffsets && activity.pingOffsets.length > 0 ? activity.pingOffsets[0] : '';
						nodes.pingOffset2.value = activity.pingOffsets && activity.pingOffsets.length > 1 ? activity.pingOffsets[1] : '';
						nodes.pingOffset3.value = activity.pingOffsets && activity.pingOffsets.length > 2 ? activity.pingOffsets[2] : '';
						editor.set(activity.layout ?? '{}');
					}
				}
			);

			return false;
		});

		nodes.updateButton.addEventListener('click', (e) => {
			e.preventDefault();

			const data = getData();
			data.id = nodes.activityId.value;
			if (!data.id)
			{
				alert('Укажите ИД дела');
				return false;
			}

			startLoading();

			BX24.callMethod(
				'crm.activity.configurable.update',
				data,
				(result) =>
				{
					stopLoading();
					if(result.error())
					{
						alert("Error: " + result.error());
					}
					else
					{
					}
				}
			);

			return false;
		});
	});
</script>
</body>
</html>